> For the complete documentation index, see [llms.txt](https://docs.eximee.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.eximee.com/documentation/documentation-en/budowanie-aplikacji/proces-biznesowy/model-danych-w-procesie.md).

# Data model in the process

To be able to use **data model** in the process, you need to perform the following steps:

1. **Create a data model.**
2. **Link the data model keys bidirectionally with the application**\
   (details described in the section [*Data model on the interface*](/documentation/documentation-en/budowanie-aplikacji/interfejs-uzytkownika/formularze/praca-z-komponentami-bazowymi/model-danych-na-interfejsie.md)).
3. **Start the application with the assigned data model.**

After performing the above steps, the data model is available in the process.

***

### Where can the data model be used?

The data model can be used in:

* **script tasks**,
* **user tasks**,
* **subprocesses**.

***

### Limitations — where do the model keys not work?

Data model keys **do not work** in:

* BPMN gateways,
* script **BPMN ScriptTasks**.([BPMS script task (scriptTask)](/documentation/documentation-en/budowanie-aplikacji/proces-biznesowy/zadania-automatyczne/zadanie-skryptowe-bpms-scripttask.md))

If we want to use model data in these BPMN elements, we need to **map them to process variables**.\
More information in the section [*Passing data to the process*](/documentation/documentation-en/budowanie-aplikacji/proces-biznesowy/przekazywanie-danych-do-procesu.md).

***

### modelInstanceId – access to the model instance

A process that uses the data model automatically receives the variable:

**`modelInstanceId`**

It is the identifier of the data model instance in which the model values are stored.\
All operations on the data model during the process use this variable.

***

### Script tasks

A detailed description of using the data model in script tasks can be found here:\
[Script task API](/documentation/documentation-en/budowanie-aplikacji/logika-biznesowa/scriptcode/zadanie-skryptowe-scripttask/api-zadan-skryptowych.md#model-danych) and [Data model API](/documentation/documentation-en/budowanie-aplikacji/model-danych/wykorzystanie-modelu-danych/api-modelu-danych.md).

***

### User tasks

In UserTasks, using the data model consists of using the model keys just as in the section [Data model on the interface](/documentation/documentation-en/budowanie-aplikacji/interfejs-uzytkownika/formularze/praca-z-komponentami-bazowymi/model-danych-na-interfejsie.md).

***

### Subprocesses

To use the data model in a subprocess:

1. Pass the variable to the subprocess **`modelInstanceId`**.
2. Variable name **must be identical** as in the calling process.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.eximee.com/documentation/documentation-en/budowanie-aplikacji/proces-biznesowy/model-danych-w-procesie.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
